package ejbs;

import java.util.Vector;

/**
 * Bean implementation class for Enterprise Bean: AddressBook
 */
public class AddressBookBean implements javax.ejb.EntityBean {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public ejbs.AddressBookKey ejbCreate() throws javax.ejb.CreateException {
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate() throws javax.ejb.CreateException {
	}
	/**
	 * ejbFindByPrimaryKey
	 */
	public ejbs.AddressBookKey ejbFindByPrimaryKey(
		ejbs.AddressBookKey primaryKey) throws javax.ejb.FinderException {
		return null;
	}
	
	/**
	 * Inserts a new entry into the address book
	 * @param name String
	 * @param address String
	 * @param phoneNumber String
	 */
	public void newEntry(String name, String address, String phoneNumber) {
		BookEntry newEntry = new BookEntry(name, address, phoneNumber);
		book.add(newEntry); 
	}
	
	/**
	 * Removes an entry from the address book
	 * @param name String
	 * @param address String
	 * @param phoneNumber String
	 */
	public void removeEntry(String name, String address, String phoneNumber) {
		int index = this.findEntry(name, address, phoneNumber);
		if(index > -1)
			book.remove(index);
	}
	
	/**
	 * Returns a String representation of all the entries in the address book
	 * @return String
	 */
	public String viewAddressBook() {
		String addressBook = "";
		BookEntry tempEntry = new BookEntry();
		for (int i = 0; i < book.size(); i++) {
			tempEntry = (BookEntry)book.get(i);
			addressBook = addressBook + printEntry(tempEntry);
		}
		return addressBook;
	}
	
	/**
	 * Returns the location of an Entry in the address book given name, address and phone number
	 * @param name String
	 * @param address String
	 * @param phoneNumber String
	 * @return int index
	 */
	public int findEntry(String name, String address, String phoneNumber) {
		BookEntry tempEntry = new BookEntry();
		for(int i = 0; i < book.size(); i++) {
			tempEntry = (BookEntry)book.get(i);
			if(tempEntry.getName().equals(name)
				&& tempEntry.getAddress().equals(address)
				&& tempEntry.getPhoneNumber().equals(phoneNumber)){
					return i;
				}
		}
		return -1;		
	}
	
	/**
	 * Finds and returns the address book entry(s) that match a given name
	 * @param name String
	 * @return String
	 */
	public String findEntry(String field) {
		BookEntry tempEntry = new BookEntry();
		for(int i = 0; i < book.size(); i++) {
			tempEntry = (BookEntry)book.get(i);
			if(tempEntry.getName().equals(field) || 
					tempEntry.getAddress().equals(field) ||
					tempEntry.getPhoneNumber().equals(field)) {
					return printEntry(tempEntry);
				}
		}
		return "No entry found";		
	}
	
	/**
	 * Returns a string representation of an address book entry
	 * @param tempEntry BookEntry
	 * @return String
	 */
	private String printEntry(BookEntry tempEntry) {
		return tempEntry.getName() + "; " +
		tempEntry.getAddress() + "; " + tempEntry.getPhoneNumber() + "\n";
	}
	
	//private BookEntry entry = new BookEntry();
	private Vector book = new Vector();
}

final class BookEntry {
	
	public BookEntry() {
		
	}
	
	public BookEntry(String newName, String newAddress, String newPhoneNumber) {
		name = newName;
		address = newAddress;
		phoneNumber = newPhoneNumber;
	}
	
	public void setName (String newName) {
		name = newName;
	}
	
	public void setAddress (String newAddress) {
		address = newAddress;
	}
	
	public void setPhoneNumber (String newPhoneNumber) {
		phoneNumber = newPhoneNumber;
	}
	
	public String getName() {
		return name;
	}
	
	public String getAddress() {
		return address;
	}
	
	public String getPhoneNumber() {
		return phoneNumber;
	}
	
	private String name;
	private String address;
	private String phoneNumber;

}
